#ifndef _MY_CRECT_
#define _MY_CRECT_

#include "math.h"


class CPoint{
 public:
  CPoint():
    x(0), y(0){
  }

  CPoint(int _x, int _y):
    x(_x),y(_y){
  }

  CPoint & operator = (const CPoint &pt) {
    x = pt.x;
    y = pt.y;
    return *this;
  }

 public:
  int x;
  int y;
};

class CRect{
  
 public:
  CRect() : m_x1(0),m_y1(0),m_x2(0),m_y2(0){
  }

  CRect(int x1, int y1, int x2, int y2) :
    m_x1(x1),m_y1(y1),m_x2(x2),m_y2(y2){
  }

  CRect(const CRect& r) :
    m_x1(r.m_x1),m_y1(r.m_y1),m_x2(r.m_x2),m_y2(r.m_y2){

    m_point_vector = r.m_point_vector;
  }

  CRect(CPoint& p1,CPoint& p2) :
    m_x1(p1.x),m_y1(p1.y),m_x2(p2.x),m_y2(p2.y){
  }

  // to do
  void IntersectRect(CRect &inter,const CRect &rect2){
    //???
    //inter.m_x1 = max(rect2.m_x2 - m_x1 + rect2.m_x1,0);
    //inter.m_y1 = max(rect2.m_y2 - m_y1 + rect2.m_y1,0);
    //inter.m_x2 = max(rect2.m_x1 - m_x2 + rect2.m_x2,0);
    //inter.m_y2 = max(rect2.m_y1 - m_y2 + rect2.m_y2,0);
  }

  // to do
  void UnionRect(CRect &uni,const CRect &rect2){
    uni.m_x1 = min(m_x1,rect2.m_x1);
    uni.m_x2 = max(m_x2,rect2.m_x2);
    uni.m_y1 = min(m_y1,rect2.m_y1);
    uni.m_y2 = max(m_y2,rect2.m_y2);
  }

  void SetRect(CPoint& p1,CPoint& p2){
    m_x1 = p1.x;
    m_y1 = p1.y;
    m_x2 = p2.x;
    m_y2 = p2.y;
  }

  bool IsRectEmpty(){
    return (m_x1 == m_x2 || m_y1 == m_y2) ;
  }
  int Height(){
    return abs( m_y2 - m_y1 );
  }
  int Width(){
    return abs( m_x2 - m_x1 );
  }

  CPoint TopLeft(){
    return CPoint(m_x1, m_y1);
  }

  CPoint BottomRight(){
    return CPoint(m_x2, m_y2);
  }

  int operator==(const CRect &rect) const{
    return ( m_x1 == rect.m_x1 && m_y1 == rect.m_y1 &&
	     m_x2 == rect.m_x2 && m_y2 == rect.m_y2);
  }

  CRect& operator=(const CRect &rect){
    m_x1 = rect.m_x1;
    m_y1 = rect.m_y1;
    m_x2 = rect.m_x2;
    m_y2 = rect.m_y2;

    //copying the point vector
    m_point_vector = rect.m_point_vector;

    return *this;
  }

  void add_point(const CPoint &pt) {
    m_point_vector.push_back(pt);
  }

  vector<CPoint> & get_point_vector(){
    return m_point_vector;
  }
  
 private:

  int m_x1;
  int m_y1;
  int m_x2;
  int m_y2;
  vector<CPoint> m_point_vector;
};

#endif
