// RGB24Image.h: interface for the RGB24Image class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _RGB_IMAGE_H_
#define _RGB_IMAGE_H_

/*
METEOR_GEO_RGB24	
RBG 24 bits packed in 32 bits
00000000 rrrrrrrr gggggggg bbbbbbbb
*/

#include "Image.h"

class RGB24Image  : public Image
{

public:
  RGB24Image (const RGB24Image &copy);
  RGB24Image (int width, int height, unsigned char *data);
  RGB24Image(int width, int height);
  RGB24Image();
  unsigned long get_pixel(int x, int y) { return ((unsigned long) m_data[y * 4 * m_height + x]);}
  virtual ~RGB24Image();
  virtual bool write_ppm (string &filename);
  virtual bool read_ppm (string &filename);
  virtual void draw_rect(CRect &rect, unsigned char val = 255);
 private:
  
  static const long RED_MASK;
  static const long GREEN_MASK;
  static const long BLUE_MASK;
  
};

#endif 
